#include "vector.h"

Vector::Vector()
    : elements( new double[DefaultElementCount] )
    , elementCount( DefaultElementCount )
{
}

Vector::Vector( unsigned int eleCount )
    : elements( new double[eleCount] )
    , elementCount( eleCount )
{
}

Vector::Vector( const Vector &other )
    : Vector( other.elementCount )
{
    for (unsigned int i=0; i<elementCount; i++)
        elements[i] = other.elements[i];
}

Vector::~Vector()
{
    delete[] elements;
}

unsigned int Vector::getElementCount() const
{
    return elementCount;
}

double &Vector::operator[]( unsigned int index )
{
    return elements[index];
}

double Vector::operator[]( unsigned int index ) const
{
    return elements[index];
}

Vector Vector::operator *( double rhs )
{
    Vector result(elementCount);
    for (unsigned int i=0; i<elementCount; i++)
        result[i] = (*this)[i] * rhs;
    return result;
}
